#include <sys/types.h>
#include <sys/stat.h>
#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <stdlib.h>
#include <strings.h>

#define _POSIX_SOURCE 1


struct termios original_tio,newtio;
void termrestore(void) 
{
	tcsetattr(0, TCSADRAIN, &original_tio);
	fprintf(stderr, "\nExit with termrestore\n");
}


void perror_exit(int status, const char *s)
{
    perror(s);
    exit(status);
}

main()
{
    int fd,c, res;    
    char buf[0x1000];
    int mtty, stty;
    char *tty_name;
    fd_set rfds;
    
    
    if(tcgetattr(fd,&original_tio) == 0)
	{
		atexit(termrestore);
	}
        
    // get the pts
    if((mtty = getpt()) == -1)
    {
        perror_exit(0, "getpt");
    }
    
    if(grantpt(mtty) == -1)
    {
        perror_exit(0, "grantpt");
    }
    
    if(unlockpt(mtty) == -1)
    {
        perror_exit(0, "unlockpt");
    }
    
    if((tty_name = (char *)ptsname(mtty)) == 0)
    {
        perror_exit(0, "ptsname");
    }
    
    if((stty = open(tty_name, O_RDWR, 0)) == -1)
    {
        perror_exit(0, "open");
    }
    
    if(!fork())
    {
        close(mtty);
        
        setsid();
        ioctl(stty, TIOCSCTTY, NULL);
        
		bzero(&newtio, sizeof(newtio));
        newtio.c_lflag = ICANON;
        newtio.c_oflag = 0;
        
//		newtio.c_lflag = ( ICANON | ISIG | ECHO | ECHOE | ECHOK | ECHONL);
//        newtio.c_iflag |= IGNPAR;
//        newtio.c_iflag &= ~(ISTRIP | INLCR | IGNCR | ICRNL | IXON | IXANY | IXOFF);
//        newtio.c_lflag &= ~(ISIG | ECHOE | ECHOK | ECHONL);
//        newtio.c_lflag |= ICANON;
//        newtio.c_oflag &= ~OPOST;
//        newtio.c_cc[VMIN] = 1;
//        newtio.c_cc[VTIME] = 0;
        
        tcflush(stty, TCIFLUSH);
        tcsetattr(0, TCSANOW, &newtio);

        putenv("HISTFILE=/dev/null");

        dup2(stty, 0);
        dup2(stty, 1);
        dup2(stty, 2);
        execl("/bin/sh","sh", NULL);
        execl("/bin/bash","bash",NULL);
        
        exit(0);
    }

    close(stty);
    
    int i;
    int esc;
    while (1)
    {      
        FD_ZERO(&rfds);
        FD_SET(0, &rfds);
        FD_SET(mtty, &rfds);
        
        if (select(mtty + 1, &rfds, NULL, NULL, NULL) == -1)
        {
            break;
        }


        if (FD_ISSET(mtty, &rfds)) 
        {
            i = read(mtty, buf, sizeof(buf));
            if (i <= 0) 
            {
                break;
            }
            if (write(0, buf, i) != i) 
            {
                break;
            }
        }

        if (FD_ISSET(0, &rfds)) 
        {
            i = read(0, buf, sizeof(buf));
            if (i <= 0)
            {
                break;
            }            
            if (write(mtty, buf, i) != i)
            {
                break;
            }
        }
        
    }
}

